<template>
  <div>
    <!--引用表格-->
    <BasicTable @register="registerTable" :rowSelection="rowSelection">
      <!--插槽:table标题-->
      <template #tableTitle>
        <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
        <a-button type="primary" @click="handleShowCheckView" preIcon="ant-design:plus-outlined">查看节点视图</a-button>
        <!-- <a-button  type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button  type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button> -->
        <a-dropdown v-if="selectedRowKeys.length > 0">
          <template #overlay>
            <a-menu>
              <a-menu-item key="1" @click="batchHandleDelete">
                <Icon icon="ant-design:delete-outlined" />
                删除
              </a-menu-item>
            </a-menu>
          </template>
          <a-button
            >批量操作
            <Icon icon="mdi:chevron-down" />
          </a-button>
        </a-dropdown>
      </template>
      <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
      </template>
    </BasicTable>
    <!-- 表单区域 -->
    <WbCheckModal @register="registerModal" @success="handleSuccess" />
    <WbCheckItemDrawer @register="registerWbCheckItemDrawer" />
    <WbCheckMtricDrawer @register="registerWbCheckMtricDrawer" />

    <WbCheckViewDrawer @register="registerWbCheckViewDrawer" />
  </div>
</template>

<script lang="ts" name="wb.config-wbCheck" setup>
  import { ref, computed, unref } from 'vue';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { useModal } from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage';
  import WbCheckModal from './components/WbCheckModal.vue';
  import { columns, searchFormSchema } from './WbCheck.data';
  import { list, deleteOne, batchDelete, getImportUrl, getExportUrl } from './WbCheck.api';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import { useDrawer } from '/@/components/Drawer';

  import WbCheckItemDrawer from './components/WbCheckItemDrawer.vue';
  import WbCheckMtricDrawer from './components/WbCheckMtricDrawer.vue';
  import WbCheckViewDrawer from './components/WbCheckViewDrawer.vue';

  import { useRoute, useRouter } from 'vue-router';
  const route = useRoute();
  const router = useRouter();

  const sceneId = Number(route.query.sceneId);
  const sceneName = Number(route.query.sceneName);

  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, { openModal }] = useModal();
  const [registerWbCheckItemDrawer, { openDrawer }] = useDrawer();
  const [registerWbCheckMtricDrawer, { openDrawer: openMtricModal }] = useDrawer();

  const [registerWbCheckViewDrawer, { openDrawer: openCheckViewModal }] = useDrawer();

  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: '节点',
      api: list,
      columns,
      canResize: true,
      formConfig: {
        //labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
        fieldMapToNumber: [],
        fieldMapToTime: [],
      },
      actionColumn: {
        width: 380,
        fixed: 'right',
      },
      beforeFetch: (params) => {
        if (sceneId) {
          Object.assign(params, { sceneId: sceneId });
        }
      },
    },
  });

  const [registerTable, { reload }, { rowSelection, selectedRowKeys }] = tableContext;

  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '编辑',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '内控要求',
        onClick: handleOpenDrawer.bind(null, record),
      },
      {
        label: '监测指标',
        onClick: handleOpenMtricDrawer.bind(null, record),
      },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '删除',
        popConfirm: {
          title: '是否确认删除',
          confirm: handleDelete.bind(null, record),
        },
      },
    ];
  }

  function handleOpenDrawer(record) {
    openDrawer(true, record);
  }

  function handleOpenMtricDrawer(record) {
    openMtricModal(true, record);
  }

  function handleShowCheckView() {
    openCheckViewModal(true, { sceneId });
  }
</script>

<style scoped></style>
